load GUE30K.dat
load BMGclean.dat
[T,n]=size(Boivin);
R1=(GUE30K(1,:)-GUE30K(2,:))./(GUE30K(2,:)-GUE30K(3,:));
R2=max((GUE30K(1:2,:)-GUE30K(2:3,:))./(GUE30K(2:3,:)-GUE30K(3:4,:)));
R3=max((GUE30K(1:3,:)-GUE30K(2:4,:))./(GUE30K(2:4,:)-GUE30K(3:5,:)));
R4=max((GUE30K(1:4,:)-GUE30K(2:5,:))./(GUE30K(2:5,:)-GUE30K(3:6,:)));
R5=max((GUE30K(1:5,:)-GUE30K(2:6,:))./(GUE30K(2:6,:)-GUE30K(3:7,:)));
ro_computation_BMG
X=[ones(T,1) BMGclean(:,1) BMGclean(:,end)];
Y=BMGclean(:,2:end-1);
beta=inv(X'*X)*X'*Y;
resid=Y-X*beta;
stresid=resid./kron(std(resid),ones(T,1));
[V,D]=eig(stresid*stresid');
%d=flipdim(diag(D),1);
%d=cumsum(d)/sum(d);
%d(5)
%disp('hit any key when ready')
%pause
Factors=flipdim(V(:,end-4:end),2);
Lambda=Factors'*stresid;
systematic=Factors*Lambda;
stsyst=std(systematic);
%plot(stsyst)
%disp('hit any key when ready')
%pause
idiosmult=sqrt(1-stsyst.^2);
for ii=1:8000
    ii
[Uhlig_base, Uhlig_resid, Uhlig_stand]=Uhlig_generator(Ro,sY);
DATA=[Uhlig_base, Uhlig_stand.*kron(idiosmult,ones(83,1))+systematic, Uhlig_stand];
n=[0;243;241;241];
nsum=cumsum(n);
m=30;
T=83;
theta=0;
for i=2:3
    %i
    data=DATA(:,nsum(i)+1:nsum(i+1));
    freqdata=[];
    for jjj=1:m
        freqdata=[freqdata;exp(-sqrt(-1)*(1:T)*(theta+2*pi*(jjj+1)/T))*data];
    end
    [V,D]=eig(freqdata'*freqdata);
    d=flipdim(sort(abs(diag(D))),1);
    r=(d(1:5,1)-d(2:6,1))./(d(2:6,1)-d(3:7,1));
    Rstat=[r(1,1);max(r(1:2,1));max(r(1:3,1));max(r(1:4,1));max(r(1:5,1))];
pval_1(ii,i-1)=sum(R1>Rstat(1,1))/30000;
pval_2(ii,i-1)=sum(R2>Rstat(2,1))/30000;
pval_3(ii,i-1)=sum(R3>Rstat(3,1))/30000;
pval_4(ii,i-1)=sum(R4>Rstat(4,1))/30000;
pval_5(ii,i-1)=sum(R5>Rstat(5,1))/30000;
end
end


xi=[0.002;0.004;0.006;0.008;(0.01:0.01:0.99)';0.992;0.994;0.996;0.998];
for i=1:107
size1(i,:)=sum(pval_1<xi(i))/8000;
size2(i,:)=sum(pval_2<xi(i))/8000;
size3(i,:)=sum(pval_3<xi(i))/8000;
size4(i,:)=sum(pval_4<xi(i))/8000;
size5(i,:)=sum(pval_5<xi(i))/8000;
end
size_full=[size1 size2 size3 size4 size5];