% implementation of the Connor-korajczyk test of k factors vs. k+1
function out=ConKor(k,X)
[n,T]=size(X);
%opts.disp=0;
[V,D]=eig(X*X'/T);
%size(V)
[Dvec,ind]=sort(abs(diag(D)));
Dvec=flipdim(Dvec,1);
%plot(diag(D))
ind=flipdim(ind,1);
V=V(:,ind(1:k+1,1))*sqrt(n);
F=V'*X/n;
epsil_star=X-V*F;
epsil=X-V(:,1:(end-1))*F(1:(end-1),:);
sig=epsil.^2/(1-(k)/T-(k)/n);
sig_star=epsil_star.^2/(1-(k+1)/T-(k+1)/n);
sig1=sig(:,1:2:(T-1));
sig2=sig_star(:,2:2:T);
delta=mean(sig1-sig2)';
out1=mean(delta);
nu=floor((T/2)^(1/4));
G=2*(delta-out1)'*(delta-out1)/T;
for i=1:nu
    G=G+(1-i/(nu+1))*4*(delta(1:(end-i),1)-out1)'*(delta((1+i):end,1)-out1)/T;
end
out=sqrt(T/2)*out1/sqrt(G);